unit main_u;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, StdCtrls, ComCtrls, ExtCtrls, inifiles,jpeg,strutils,
  Buttons;

const
  _caption='www.daniel-schwamm.de|PHP Project Checker V1.0';

  _ini_fn      ='PHPProjectChecker.ini';
  _projects_dir='projects\';
  _ppc_ext     ='.ppc';
  _unknown_fn  ='unknown'+_ppc_ext;
  _php_kw_fn   ='php_kw.txt';

  _cr=#13#10;

  _debug_error       ='error</B>:';
  _debug_warn        ='Warning</B>:';
  _debug_notice      ='Notice</B>:';
  _debug_syntax_error='Parse error';
  _debug_syntax_fn   ='syntax_check.tmp';

  _db_warning='WARNING';
  _db_error  ='ERROR  ';
  _db_notice ='NOTICE ';

  _active_color  =$0080FFFF;
  _inactive_color=clsilver;

type
  Tmain_f = class(TForm)
    main_menu: TMainMenu;
    file1: TMenuItem;
    file_exit1: TMenuItem;
    start1: TMenuItem;
    start_syntax_check1: TMenuItem;
    start_run1: TMenuItem;
    top_p: TPanel;
    src_m: TMemo;
    pctrl: TPageControl;
    project_ts: TTabSheet;
    project_functions_ts: TTabSheet;
    php_functions_ts: TTabSheet;
    project_p: TPanel;
    project_lb: TListBox;
    project_add_b: TButton;
    project_del_b: TButton;
    project_open_dlg: TOpenDialog;
    pctrl_splitter: TSplitter;
    debug_lb_splitter: TSplitter;
    project_functions_lb: TListBox;
    php_functions_lb: TListBox;
    project_save_dlg: TSaveDialog;
    file_n2: TMenuItem;
    file_project_new1: TMenuItem;
    file_project_open1: TMenuItem;
    file_project_save1: TMenuItem;
    file_project_save_under1: TMenuItem;
    file_project_close1: TMenuItem;
    open_dlg: TOpenDialog;
    save_dlg: TSaveDialog;
    file_n1: TMenuItem;
    file_ed_save1: TMenuItem;
    status_p: TPanel;
    cursor_p: TPanel;
    top_img: TImage;
    url_l: TLabel;
    project_url_e: TEdit;
    project_url_ed_rb: TRadioButton;
    project_url_file_rb: TRadioButton;
    project_url_file_e: TEdit;
    files_l: TLabel;
    edit1: TMenuItem;
    edit_search1: TMenuItem;
    edit_search_project1: TMenuItem;
    edit_goto_line1: TMenuItem;
    start_browser1: TMenuItem;
    edit_search_again1: TMenuItem;
    lb_pctrl: TPageControl;
    search_ts: TTabSheet;
    debug_ts: TTabSheet;
    debug_lb: TListBox;
    search_lb: TListBox;
    file_project_new_sb: TSpeedButton;
    file_project_open_sb: TSpeedButton;
    file_project_save_sb: TSpeedButton;
    file_project_save_under_sb: TSpeedButton;
    file_project_close_sb: TSpeedButton;
    edit_search_sb: TSpeedButton;
    edit_search_again_sb: TSpeedButton;
    edit_search_project_sb: TSpeedButton;
    edit_goto_line_sb: TSpeedButton;
    start_syntax_check_sb: TSpeedButton;
    start_run_sb: TSpeedButton;
    start_browser_sb: TSpeedButton;
    file_ed_save_sb: TSpeedButton;

    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormShow(Sender: TObject);

    procedure file_project_new1Click(Sender: TObject);
    procedure file_project_open1Click(Sender: TObject);
    procedure file_project_save1Click(Sender: TObject);
    procedure file_project_save_under1Click(Sender: TObject);
    procedure file_project_close1Click(Sender: TObject);
    procedure file_ed_save1Click(Sender: TObject);
    procedure file_exit1Click(Sender: TObject);

    procedure edit_search1Click(Sender: TObject);
    procedure edit_search_project1Click(Sender: TObject);
    procedure edit_goto_line1Click(Sender: TObject);
    procedure edit_search_again1Click(Sender: TObject);

    procedure start_syntax_check1Click(Sender: TObject);
    procedure start_run1Click(Sender: TObject);
    procedure start_browser1Click(Sender: TObject);

    procedure debug_lbDblClick(Sender: TObject);
    procedure debug_lbDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure project_del_bClick(Sender: TObject);
    procedure search_lbDblClick(Sender: TObject);

    procedure project_url_ed_rbClick(Sender: TObject);
    procedure project_add_bClick(Sender: TObject);
    procedure project_lbDblClick(Sender: TObject);

    procedure src_mKeyUp(Sender: TObject; var Key: Word;Shift: TShiftState);
    procedure src_mClick(Sender: TObject);
    procedure project_functions_lbDblClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    home_dir:string;
    project_fn:string;
    src_fn:string;

    procedure project_new;
    procedure project_load(fn:string);
    procedure project_save(fn:string);
    procedure project_save_under;
    function project_close:bool;

    procedure src_load(fn:string);
    procedure src_save;
    function src_save_check:bool;
    procedure src_cursor_pos;

    procedure error_msg(s:string);
    procedure notice_msg(s:string);
    procedure status_set(s:string);
    procedure components_set;
    procedure lb_scrollwidth_set(lb:tlistbox);


    function short_fn(fn:string):string;
    function long_fn(fn:string):string;
    procedure pos_to_xy(s:string;pos_c:integer;var x,y:integer);
    function xy_to_pos(s:string;x,y:integer):integer;
    function rpos(search,s:string):integer;
    function count_search_in_str(search,s:string):integer;
    function delim_param_get(s:string;nr:byte;delim_ch:char;default:string):string;
    function itoa(i:integer):string;

    procedure debug_add(title,fn:string;y,x:integer;func_name,var_name,msg:string);
  end;

var
  main_f: Tmain_f;

implementation

uses web_u,syntax_check_u,search_u;

{$R *.dfm}

//---------------------------------------------------------
//FORM
//---------------------------------------------------------

procedure Tmain_f.FormCreate(Sender: TObject);
begin
  home_dir:=extractfilepath(application.exename);
  project_open_dlg.InitialDir:=home_dir+_projects_dir;
  project_save_dlg.InitialDir:=home_dir+_projects_dir;
  top_p.ParentBackground:=false;top_p.Color:=clbtnface;
  top_img.Align:=alclient;
  pctrl.ActivePage:=project_ts;
  project_lb.align:=alclient;
  project_functions_lb.align:=alclient;
  search_lb.Align:=alclient;
  debug_lb.align:=alclient;

  php_functions_lb.align:=alclient;
  try
    php_functions_lb.Items.LoadFromFile(home_dir+_php_kw_fn);
    lb_scrollwidth_set(php_functions_lb);
  except
  end;
  src_m.align:=alclient;
  status_p.ParentBackground:=false;status_p.Color:=clbtnface;
  project_fn:='';
  components_set;
end;

procedure Tmain_f.FormShow(Sender: TObject);
var
  s,fn:string;
  maximized_ok:bool;
  r:integer;
begin
  with tinifile.Create(home_dir+_ini_fn) do
  begin
    left:=readinteger('window','left',left);
    top:=readinteger('window','top',top);
    width:=readinteger('window','width',width);
    height:=readinteger('window','height',height);
    maximized_ok:=readbool('window','maximized_ok',false);
    if maximized_ok then WindowState:=wsmaximized;
    pctrl.width:=readinteger('window','left_width',pctrl.width);
    lb_pctrl.height:=readinteger('window','bottom_height',lb_pctrl.height);

    syntax_check_f.php_fn_e.text:=readstring('param','php_fn',syntax_check_f.php_fn_e.text);
    syntax_check_f.lint_chb.checked:=readbool('param','php_lint',syntax_check_f.lint_chb.checked);
    syntax_check_f.functions_unknown_chb.checked:=readbool('param','functions_unknown',syntax_check_f.functions_unknown_chb.checked);
    syntax_check_f.functions_unused_chb.checked:=readbool('param','functions_unused',syntax_check_f.functions_unused_chb.checked);
    syntax_check_f.variables_unknown_chb.checked:=readbool('param','variables_unknown',syntax_check_f.variables_unknown_chb.checked);
    syntax_check_f.variables_unused_chb.checked:=readbool('param','variables_unused',syntax_check_f.variables_unused_chb.checked);

    search_f.case_chb.Checked:=readbool('search','case',search_f.case_chb.Checked);
    r:=0;
    repeat
      s:=readstring('search','search_'+inttostr(r),'');
      if(s<>'')and(search_f.search_cb.Items.IndexOf(s)=-1) then search_f.search_cb.Items.add(s);
      inc(r);
    until s='';

    fn:=readstring('param','project_fn','');
    free;
  end;
  if fn<>'' then project_load(fn);
end;

procedure Tmain_f.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var
  r,r_max:integer;
begin
  canclose:=false;if not src_save_check then exit;
  canclose:=true;
  project_save(project_fn);
  deletefile(home_dir+_ini_fn);
  with tinifile.Create(home_dir+_ini_fn) do
  begin
    writebool('window','maximized_ok',(WindowState=wsmaximized));
    if WindowState<>wsmaximized then
    begin
      writeinteger('window','left',left);
      writeinteger('window','top',top);
      writeinteger('window','width',width);
      writeinteger('window','height',height);
    end;
    writeinteger('window','left_width',pctrl.width);
    writeinteger('window','bottom_height',lb_pctrl.height);

    writestring('param','php_fn',syntax_check_f.php_fn_e.text);
    writebool('param','php_lint',syntax_check_f.lint_chb.checked);
    writebool('param','functions_unknown',syntax_check_f.functions_unknown_chb.checked);
    writebool('param','functions_unused',syntax_check_f.functions_unused_chb.checked);
    writebool('param','variables_unknown',syntax_check_f.variables_unknown_chb.checked);
    writebool('param','variables_unused',syntax_check_f.variables_unused_chb.checked);
    writestring('param','project_fn',project_fn);

    writebool('search','case',search_f.case_chb.Checked);
    r_max:=search_f.search_cb.Items.count-1;if r_max>20 then r_max:=20;
    for r:=0 to r_max do
    begin
      writestring('search','search_'+inttostr(r),search_f.search_cb.Items[r]);
    end;

    free;
  end;
end;

//---------------------------------------------------------
//MENU FILE
//---------------------------------------------------------

procedure tmain_f.project_new;
begin
  project_save(project_fn);
  project_fn:='';
  project_url_file_e.Text:='index.php';
  project_url_ed_rb.checked:=true;
  src_fn:='';
  project_save_under;
end;

procedure Tmain_f.file_project_new1Click(Sender: TObject);
begin
  project_new;
end;

procedure tmain_f.project_load(fn:string);
var
  r:integer;
  s:string;
begin
  project_close;
  screen.Cursor:=crhourglass;
  with tinifile.Create(fn) do
  begin
    project_fn:=fn;
    r:=0;
    repeat
      s:=readstring('files','file_'+inttostr(r),'');
      if(s<>'')and(project_lb.Items.indexof(s)=-1) then
      begin
        if fileexists(long_fn(s)) then project_lb.Items.add(short_fn(s));
      end;
      inc(r);
    until s='';
    lb_scrollwidth_set(project_lb);

    project_url_e.text:=readstring('options','url','http://localhost/projects/');
    project_url_ed_rb.checked:=readbool('options','project_url_ed_ok',true);
    project_url_file_rb.checked:=readbool('options','project_url_file_ok',false);
    project_url_file_e.Text:=readstring('options','project_url_file','index.php');

    s:=readstring('source','src_fn','');
    if s<>'' then src_load(long_fn(s));
    free;
  end;
  status_set('Project "'+fn+'" loaded');
  components_set;
  screen.Cursor:=crdefault;
end;

procedure Tmain_f.file_project_open1Click(Sender: TObject);
begin
  if not project_open_dlg.execute then exit;
  project_load(project_open_dlg.FileName);
end;

procedure tmain_f.project_save(fn:string);
var
  r:integer;
begin
  if fn='' then exit;
  screen.Cursor:=crhourglass;
  deletefile(fn);
  with tinifile.Create(fn) do
  begin
    for r:=0 to project_lb.Items.count-1 do
    begin
      writestring('files','file_'+inttostr(r),project_lb.items[r]);
    end;
    writestring('options','url',project_url_e.text);
    writebool('options','project_url_ed_ok',project_url_ed_rb.checked);
    writebool('options','project_url_file_ok',project_url_file_rb.checked);
    writestring('options','project_url_file',project_url_file_e.Text);
    writestring('source','src_fn',short_fn(src_fn));
    free;
  end;
  project_fn:=fn;
  status_set('Project "'+fn+'" saved');
  components_set;
  screen.Cursor:=crdefault;
end;

procedure Tmain_f.file_project_save1Click(Sender: TObject);
begin
  project_save(project_fn);
end;

procedure tmain_f.project_save_under;
var
  fn:string;
begin
  project_close;
  fn:=project_fn;
  if fn='' then fn:=home_dir+_projects_dir+_unknown_fn;
  project_save_dlg.initialdir:=extractfilepath(fn);
  if not project_save_dlg.execute then exit;
  project_save(project_save_dlg.FileName);
end;

procedure Tmain_f.file_project_save_under1Click(Sender: TObject);
begin
  project_save_under;
end;

function tmain_f.project_close:bool;
begin
  result:=false;if not src_save_check then exit;
  project_save(project_fn);
  if project_fn<>'' then status_set('Project "'+project_fn+'" closed');
  project_fn:='';
  project_lb.Clear;
  open_dlg.filename:='';
  components_set;
  result:=true;
end;

procedure Tmain_f.file_project_close1Click(Sender: TObject);
begin
  project_close;
end;

procedure Tmain_f.file_ed_save1Click(Sender: TObject);
begin
  src_save;
end;

procedure Tmain_f.file_exit1Click(Sender: TObject);
begin
  close;
end;

//---------------------------------------------------------
//MENU EDIT
//---------------------------------------------------------

procedure Tmain_f.edit_search1Click(Sender: TObject);
begin
  search_f.job(0);
end;

procedure Tmain_f.edit_search_again1Click(Sender: TObject);
begin
  search_f.job_search_editor(search_f.search_cb.Text,search_f.case_chb.Checked,true);
end;

procedure Tmain_f.edit_search_project1Click(Sender: TObject);
begin
  search_f.job(1);
end;

procedure Tmain_f.edit_goto_line1Click(Sender: TObject);
begin
  search_f.job(2);
end;

//---------------------------------------------------------
//MENU START
//---------------------------------------------------------

procedure Tmain_f.start_syntax_check1Click(Sender: TObject);
begin
  lb_pctrl.ActivePage:=debug_ts;
  syntax_check_f.showmodal;
  if not syntax_check_f.rc then exit;
  syntax_check_f.syntax_check;
end;

procedure Tmain_f.start_run1Click(Sender: TObject);
var
  s:string;
begin
  src_save;
  s:=trim(project_url_e.text);
  if s='' then
  begin
    error_msg('Missing Base-URL of Project');
    activecontrol:=project_url_e;
    exit;
  end;

  if s[length(s)]<>'/' then s:=s+'/';
  project_url_e.text:=s;

  if project_url_ed_rb.Checked then s:=s+project_lb.Items[project_lb.itemindex]
                               else s:=s+project_url_file_e.Text;
  web_f.tag:=0;
  web_f.url_e.Text:=s;
  web_f.home_url:=s;
  web_f.ShowModal;
  lb_scrollwidth_set(debug_lb);
end;

procedure Tmain_f.start_browser1Click(Sender: TObject);
begin
  web_f.tag:=1;
  web_f.showmodal;
end;

//---------------------------------------------------------
//SOURCE
//---------------------------------------------------------

procedure tmain_f.src_load(fn:string);
begin
  if not src_save_check then exit;
  if fn='' then exit;
  screen.Cursor:=crhourglass;
  src_m.Visible:=false;
  try
    src_m.Lines.LoadFromFile(fn);
    src_m.Visible:=true;
    src_fn:=fn;
    status_set('File "'+fn+'" loaded');
    project_lb.ItemIndex:=project_lb.Items.indexof(short_fn(src_fn));
    src_m.modified:=false;
  except
  end;
  components_set;
  screen.Cursor:=crdefault;
end;

procedure tmain_f.src_save;
begin
  if src_fn='' then exit;
  screen.Cursor:=crhourglass;
  src_m.Visible:=false;
  try
    src_m.Lines.savetoFile(src_fn);
    src_m.Visible:=true;
    status_set('File "'+src_fn+'" saved');
    src_m.modified:=false;
  except
  end;
  screen.Cursor:=crdefault;
end;

function tmain_f.src_save_check:bool;
var
  rc:integer;
begin
  result:=true;if not src_m.Modified then exit;
  rc:=application.MessageBox(pchar('File "'+src_fn+'" modified. Save?'),'*** QUESTION ***',mb_yesnocancel);
  if rc=id_no then exit;
  if rc=id_cancel then
  begin
    result:=false;
    exit;
  end;
  src_save;
end;

procedure Tmain_f.src_mClick(Sender: TObject);
begin
  src_cursor_pos;
end;

procedure Tmain_f.src_mKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  src_cursor_pos;
end;

procedure tmain_f.src_cursor_pos;
begin
  cursor_p.Caption:='Row: '+inttostr(src_m.CaretPos.y+1)+' | Column: '+inttostr(src_m.CaretPos.x+1);
end;

//---------------------------------------------------------
//PROJECT_LB
//---------------------------------------------------------

procedure Tmain_f.project_add_bClick(Sender: TObject);
var
  r:integer;
  fn:string;
begin
  if open_dlg.filename<>'' then open_dlg.InitialDir:=extractfilepath(open_dlg.filename)
                           else open_dlg.InitialDir:=extractfilepath(project_fn);
  open_dlg.filename:='';
  if not open_dlg.execute then exit;
  for r:=0 to open_dlg.files.count-1 do
  begin
    fn:=open_dlg.files[r];
    if project_lb.Items.indexof(short_fn(fn))=-1 then
    begin
      project_lb.Itemindex:=project_lb.Items.add(short_fn(fn));
      status_set('File "'+fn+'" added');
    end;
  end;
  lb_scrollwidth_set(project_lb);
  components_set;
end;

procedure Tmain_f.project_del_bClick(Sender: TObject);
begin
  if project_lb.Itemindex=-1 then exit;
  project_lb.DeleteSelected;
  lb_scrollwidth_set(project_lb);
  components_set;
end;

procedure Tmain_f.project_lbDblClick(Sender: TObject);
begin
  if project_lb.itemindex=-1 then exit;
  src_load(long_fn(project_lb.Items[project_lb.itemindex]));
end;

procedure Tmain_f.project_url_ed_rbClick(Sender: TObject);
begin
  components_set;
end;

//---------------------------------------------------------
//PROJECT_FUNCTIONS_LISTBOX
//---------------------------------------------------------

procedure Tmain_f.project_functions_lbDblClick(Sender: TObject);
var
  s,search,fn:string;
begin
  if project_functions_lb.itemindex=-1 then exit;

  //s='function - filenane'
  s:=project_functions_lb.items[project_functions_lb.itemindex];

  search:=trim(delim_param_get(s,0,'-',''));

  fn:=long_fn(trim(delim_param_get(s,1,'-','')));
  if not fileexists(fn) then
  begin
    error_msg('File "'+fn+'" not found!');
    exit;
  end;

  //editor open?
  if src_fn<>fn then src_load(fn);

  search_f.search_function_def(search);
end;

//---------------------------------------------------------
//SEARCH_LISTBOX
//---------------------------------------------------------

procedure Tmain_f.search_lbDblClick(Sender: TObject);
var
  s,fn,ss:string;
  x,y:integer;
begin
  if search_lb.itemindex=-1 then exit;

  //s='filename|y|x|source'
  s:=search_lb.Items[search_lb.itemindex];

  fn:=long_fn(trim(delim_param_get(s,0,'|','')));
  if not fileexists(fn) then
  begin
    error_msg('File "'+fn+'" not found!');
    exit;
  end;

  ss:=trim(delim_param_get(s,1,'|',''));
  y:=0;if ss<>'' then try y:=strtoint(ss);except end;

  ss:=trim(delim_param_get(s,2,'|',''));
  x:=0;if ss<>'' then try x:=strtoint(ss);except end;

  //editor open?
  if src_fn<>fn then src_load(fn);

  search_f.job_goto_xy(x,y);
  src_m.SelLength:=length(search_lb.HelpKeyword);
  activecontrol:=src_m;
end;

//---------------------------------------------------------
//DEBUG_LISTBOX
//---------------------------------------------------------

procedure tmain_f.debug_add(title,fn:string;y,x:integer;func_name,var_name,msg:string);
var
  s:string;
begin
  s:=title+'|'+short_fn(fn)+'|'+itoa(y)+'|'+itoa(x)+'|'+func_name+'|'+var_name+'|'+msg;
  debug_lb.itemindex:=debug_lb.items.add(s);
end;

procedure Tmain_f.debug_lbDblClick(Sender: TObject);
var
  s,fn,ss:string;
  x,y:integer;
begin
  if main_f.debug_lb.itemindex=-1 then exit;

  //s='warning|fn|y|x|function|var|message'
  s:=debug_lb.Items[debug_lb.itemindex];

  fn:=long_fn(trim(delim_param_get(s,1,'|','')));
  if not fileexists(fn) then
  begin
    error_msg('File "'+fn+'" not found!');
    exit;
  end;
  //editor open?
  if src_fn<>fn then src_load(fn);

  y:=strtoint(trim(delim_param_get(s,2,'|','')));
  x:=strtoint(trim(delim_param_get(s,3,'|','')));

  //no coordinates?
  if(x=0)and(y=0) then
  begin
    //search definition of unused function
    ss:=trim(delim_param_get(s,4,'|',''));
    search_f.search_function_def(ss);
    exit;
  end;

  //jump to coordinates
  search_f.job_goto_xy(x,y);

  //select variable?
  ss:=trim(delim_param_get(s,5,'|',''));
  if ss<>'' then
  begin
    src_m.SelLength:=length(ss);
  end
  else
  begin
    //select function?
    ss:=trim(delim_param_get(s,4,'|',''));
    if ss<>'' then src_m.SelLength:=length(ss);
  end;

  if src_m.SelLength=1 then src_m.SelLength:=2;
  activecontrol:=src_m;
end;

procedure Tmain_f.debug_lbDrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
var
  s:string;
  lb:tlistbox;
begin
  lb:=tlistbox(control);
  s:=lb.items[index];
  if not(odselected in state) then
  begin
    if copy(s,1,length(_db_error))  =_db_error   then lb.canvas.brush.color:=rgb(255,150,150)
    else
    if copy(s,1,length(_db_warning))=_db_warning then lb.canvas.brush.color:=rgb(255,255,150);
  end;
  lb.canvas.fillrect(rect);
  lb.canvas.textout(rect.Left+2,rect.top,s);
end;

//---------------------------------------------------------
//MESSAGE / DESIGN
//---------------------------------------------------------

procedure tmain_f.error_msg(s:string);
begin
  beep;
  application.MessageBox(pchar(s),'*** ERROR ***',mb_ok);
end;

procedure tmain_f.notice_msg(s:string);
begin
  application.MessageBox(pchar(s),'*** NOTICE ***',mb_ok);
end;

procedure tmain_f.components_set;
begin
  if project_fn='' then
  begin
    src_m.Visible:=false;
    project_lb.Color:=_inactive_color;
    caption:=_caption;
    exit;
  end;
  caption:=_caption+' - '+short_fn(project_fn);
  project_lb.Color:=_active_color;
  project_lb.visible:=false;
  project_lb.visible:=true;
  if src_m.visible then
  begin
    caption:=caption+' ['+short_fn(src_fn)+']';
  end;

  if project_url_ed_rb.checked then
  begin
    project_url_file_e.color:=_inactive_color;
    project_url_file_e.enabled:=false;
  end
  else
  begin
    project_url_file_e.color:=_active_color;
    project_url_file_e.enabled:=true;
  end;
end;

procedure tmain_f.status_set(s:string);
begin
  status_p.caption:=s;
end;

//calculate and set maximum scrollwidth of a listbox
procedure tmain_f.lb_scrollwidth_set(lb:tlistbox);
var
  r,w,w_max:integer;
begin
  lb.Canvas.font:=lb.Font;
  w_max:=0;
  for r:=0 to lb.items.count-1 do
  begin
    w:=lb.Canvas.TextWidth(lb.Items[r]);
    if w>w_max then w_max:=w;
  end;
  lb.ScrollWidth:=w_max;
end;

//---------------------------------------------------------
//STRING
//---------------------------------------------------------

//cut project-path from filename "fn"
function tmain_f.short_fn(fn:string):string;
var
  dir:string;
begin
  dir:=ansilowercase(extractfilepath(project_fn));
  if copy(ansilowercase(fn),1,length(dir))=dir then
    fn:=copy(fn,length(dir)+1,length(fn));
  result:=fn;
end;

//add project-path to filename "fn"
function tmain_f.long_fn(fn:string):string;
var
  dir:string;
begin
  dir:=ansilowercase(extractfilepath(project_fn));
  if pos(':',fn)=0 then fn:=dir+fn;
  result:=fn;
end;

//count hits of "search" in "s"
function tmain_f.count_search_in_str(search,s:string):integer;
var
  c,fc:integer;
begin
  c:=0;
  fc:=0;
  repeat
    c:=posex(search,s,c);
    if c>0 then begin
      inc(fc);
      inc(c);
    end;
  until c=0;
  result:=fc;
end;

//search backwards "search" in string "s
function tmain_f.rpos(search,s:string):integer;
var
  c:integer;

  function copy_cut(const s:string; const i:integer):string;
  begin
    result:=copy(s,i,length(s)-i+1);
  end;

begin
  for c:=length(s)-length(search)+1 downto 1 do
  begin
    if pos(search,copy_cut(s,c))=1 then
    begin
      result:=c; //found
      exit;
    end;
  end;
  result:=0; //not found
end;

//position in string to x/y-coordinates in editor
procedure tmain_f.pos_to_xy(s:string;pos_c:integer;var x,y:integer);
begin
  y:=count_search_in_str(_cr,copy(s,1,pos_c))+1;
  x:=rpos(_cr,copy(s,1,pos_c));if x>0 then x:=pos_c-x;
end;

// x/y-coordinates in editor to position in string
function tmain_f.xy_to_pos(s:string;x,y:integer):integer;
var
  c:integer;
begin
  c:=0;
  repeat
    c:=posex(_cr,s,c+1);
    dec(y);
  until y<=0;
  result:=c+x;
end;

//filter entry "nr" from delimiter-string "s" or send back "default"
//s='9|1|2|3', nr=2 => 2
function tmain_f.delim_param_get(s:string;nr:byte;delim_ch:char;default:string):string;
var
  delim_c,start_c,end_c:integer;
begin
  result:='';
  delim_c:=0;end_c:=0;
  repeat
    start_c:=end_c;
    end_c:=posex(delim_ch,s,start_c+1);
    inc(delim_c);
  until(end_c=0)or(delim_c=nr+1);

  if(end_c=0)and(delim_c<=nr) then
  begin
    result:=default;
    exit;
  end;

  if end_c=0 then end_c:=length(s)+1;
  result:=copy(s,start_c+1,end_c-start_c-1);
  if result='' then result:=default;
end;

//integer to string with lenght 6
//190 => "   190"
function tmain_f.itoa(i:integer):string;
begin
  result:=inttostr(i);
  while length(result)<6 do result:=' '+result;
end;


end.

