unit search_u;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Spin,strutils;

type
  Tsearch_f = class(TForm)
    main_p: TPanel;
    ok_b: TButton;
    break_b: TButton;
    search_editor_chb: TRadioButton;
    search_project_chb: TRadioButton;
    goto_line_chb: TRadioButton;
    goto_line_se: TSpinEdit;
    top_p: TPanel;
    search_l: TLabel;
    search_cb: TComboBox;
    case_chb: TCheckBox;
    m: TMemo;
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormShow(Sender: TObject);
    procedure ok_bClick(Sender: TObject);
    procedure break_bClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    rc:bool;
    procedure search_function_def(search:string);
    procedure fn_grep_to_lb(fn,search:string;case_ok:bool);
    procedure job_search_editor(search:string;case_ok,search_again_ok:bool);
    procedure job_search_project;
    procedure job_goto_xy(x,y:integer);
    procedure job(job_type:byte);
  end;

var
  search_f: Tsearch_f;

implementation

uses main_u;

{$R *.dfm}

//--------------------------------------------------------------
//FORM
//--------------------------------------------------------------

procedure Tsearch_f.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if key=vk_return then ok_bclick(sender)
  else
  if key=vk_escape then break_bclick(sender);
end;

procedure Tsearch_f.FormShow(Sender: TObject);
begin
  rc:=false;
end;

procedure Tsearch_f.ok_bClick(Sender: TObject);
var
  s:string;
  i:integer;
begin
  s:=search_cb.text;
  if s<>'' then
  begin
    i:=search_cb.Items.IndexOf(s);
    if i>-1 then search_cb.Items.Delete(i);
    search_cb.Items.insert(0,s);
  end;
  rc:=true;
  close;
end;

procedure Tsearch_f.break_bClick(Sender: TObject);
begin
  close;
end;

//--------------------------------------------------------------
//SEARCH
//--------------------------------------------------------------

//search function definition in project
procedure tsearch_f.search_function_def(search:string);
var
  c:integer;
  s,fkw:string;
  x,y:integer;
begin
  //search definition like "function search"
  fkw:=ansilowercase('function '+search);
  s:=ansilowercase(main_f.src_m.text);
  c:=pos(fkw,s);
  if c=0 then
  begin
    //nothing found: try without "funcion"
    c:=pos(search,s);if c=0 then exit;
    fkw:=search;
  end;
  //jump to hit
  main_f.pos_to_xy(s,c,x,y);
  search_f.job_goto_xy(x-1,y);
  main_f.src_m.SelLength:=length(fkw);
  main_f.src_m.SetFocus;
end;

//search in file "fn" the string "search". Put hits into "search_lb"
procedure tsearch_f.fn_grep_to_lb(fn,search:string;case_ok:bool);
var
  r,cc,c:integer;
  ss,s:string;
  cr_c:integer;
begin
  //save seach-string
  main_f.search_lb.HelpKeyword:=search;

  //nothing to do?
  if not fileexists(fn) then exit;

  try
    m.lines.loadfromfile(fn);
    s:=m.text;
  except
    exit;
  end;

  if not case_ok then
  begin
    search:=ansilowercase(search);
    s:=ansilowercase(s);
  end;

  //count carriage returns in search
  cr_c:=0;
  for c:=1 to length(search) do
  begin
    if search[c]=#10 then inc(cr_c);
  end;

  //search "search" in "s"
  m.text:=s;r:=0;
  while r<m.lines.count-cr_c do
  begin
    s:='';for c:=0 to cr_c do s:=s+m.Lines[r+c]+_cr;
    cc:=0;
    repeat
      c:=pos(search,s);
      if c=0 then break;
      //search found, put hit into search_lb
      ss:=
        main_f.short_fn(fn)+'|'+
        main_f.itoa(r+1)+'|'+
        main_f.itoa(c+cc)+'| '+
        copy(s,1,length(s)-2);
      main_f.search_lb.Items.add(ss);
      s:=copy(s,c+length(search),length(s));
      cc:=cc+c+length(search)-1;
    until c=0;
    inc(r,cr_c+1);
  end;
  main_f.lb_scrollwidth_set(main_f.search_lb);
end;

//search "search" in editor-text
procedure tsearch_f.job_search_editor(search:string;case_ok,search_again_ok:bool);
var
  s:string;
  c,start:integer;
begin
  if search='' then exit;

  s:=main_f.src_m.Text;
  if not case_ok then
  begin
    search:=ansilowercase(search);
    s:=ansilowercase(s);
  end;

  start:=0;
  //start at cursor-postion?
  if search_again_ok then start:=main_f.src_m.SelStart+2;

  c:=posex(search,s,start);
  if c>0 then
  begin
    //found: select hit
    main_f.src_m.Selstart:=c-1;
    main_f.src_m.SelLength:=length(search);
  end
  else
  begin
    main_f.error_msg('String "'+search+'" not found anymore!');
  end;
  main_f.ActiveControl:=main_f.src_m;
end;

//search in all project-files
procedure tsearch_f.job_search_project;
var
  r:integer;
begin
  screen.Cursor:=crhourglass;
  try
    main_f.search_lb.Clear;
    main_f.search_ts.Caption:='Search "'+copy(search_cb.text,1,40)+'"';
    for r:=0 to main_f.project_lb.Items.count-1 do
    begin
      fn_grep_to_lb(
        main_f.long_fn(main_f.project_lb.Items[r]),
        search_cb.text,
        case_chb.checked
      );
    end;
  finally
    screen.Cursor:=crdefault;
  end;
end;

//jump to x/y-coordinates in memo "src_m"
procedure tsearch_f.job_goto_xy(x,y:integer);
begin
  main_f.src_m.SelStart:=SendMessage(main_f.src_m.Handle,EM_LINEINDEX,y-1,0)+x-1;
  main_f.src_m.SelLength:=1;
  main_f.activecontrol:=main_f.src_m;
  main_f.src_cursor_pos;
end;

//pre-select job, show form, select job, do job
procedure Tsearch_f.job(job_type:byte);
begin
  main_f.lb_pctrl.ActivePage:=main_f.search_ts;

  //if text selected search this else last search word
  if main_f.src_m.SelLength>0 then search_cb.Text:=main_f.src_m.SelText
                              else search_cb.Text:=search_cb.Items[0];
  //pre-select job
  if job_type=0 then
  begin
    //search in editor
    search_editor_chb.checked:=true;
    activecontrol:=search_cb;
    search_cb.SelectAll;
  end
  else
  if job_type=1 then
  begin
    //search in all project-files
    search_project_chb.checked:=true;
    activecontrol:=search_cb;
    search_cb.SelectAll;
  end
  else
  if job_type=2 then
  begin
    //goto line
    goto_line_chb.checked:=true;
    activecontrol:=goto_line_se;
    goto_line_se.SelectAll;
  end;
  showmodal;
  if not rc then exit;

  //do selected job
  if search_editor_chb.checked then job_search_editor(search_cb.text,case_chb.checked,false)
  else
  if search_project_chb.checked then job_search_project
  else
  if goto_line_chb.checked then job_goto_xy(0,goto_line_se.Value);
end;

end.

