unit syntax_check_funcs_u;

interface

uses windows,sysutils,Classes,strutils;

function func_params_count(s,fn:string;var par_min:integer):integer;
procedure func_calls_scan(full_src,php_src:string;func_calls_sl:tstringlist);
procedure check(
  fn,
  full_src,php_src:string;
  funcs_all_sl,funcs_project_sl,funcs_unused_sl,funcs_unknown_sl,
  func_calls_sl:tstringlist
);

implementation

uses main_u,syntax_check_u;

//scan and add all function-calls in 'php_src' to 'func_calls_sl'
procedure func_calls_scan(full_src,php_src:string;func_calls_sl:tstringlist);
var
  c,start_c,end_c,cc,x,y:integer;
  func_name,pre:string;
  brace_c:integer;
begin
  c:=0;
  repeat
    //search for possible function-part
    c:=posex('(',php_src,c+1);
    if c=0 then break;

    //scan for function name: f($x) -> f
    start_c:=c;
    func_name:=syntax_check_f.word_prev(php_src,start_c);

    if start_c=0 then break;
    if trim(func_name)='' then continue;

    //ignore 'pseudo'-functions
    if
      (func_name='&')or      // if($a)$($b))
      (func_name='&&')or
      (func_name='|')or
      (func_name='||')or
      (func_name='and')or
      (func_name='or')or
      (func_name='xor')or
      (func_name='if')or     //if(...)
      (func_name='array')    //array(...)
    then continue;

    //found a function-header and not a call?
    //function f($x)?
    cc:=start_c;
    pre:=syntax_check_f.word_prev(php_src,cc);
    if ansilowercase(pre)='function' then continue;

    //guilty call found. Scan possible parameters
    end_c:=start_c+1;

    //scan for function-call-end ')'
    end_c:=posex(')',php_src,end_c);if end_c=0 then continue;

    //real call-end or parameter-brace like in:
    //tst($lim,($art=='xxx'),$lim_txt)
    end_c:=posex('(',php_src,start_c+1);
    brace_c:=1;
    repeat
      inc(end_c);if end_c>length(php_src) then break;
      if php_src[end_c]='(' then inc(brace_c);
      if php_src[end_c]=')' then dec(brace_c);
    until brace_c=0;

    ///ok, 'end_c' points to end of call

    //use full_src for function-name plus parameters
    func_name:=copy(full_src,start_c+1,end_c-start_c);

    //calculate x/y-coordinates
    main_f.pos_to_xy(php_src,start_c,x,y);

    //save function call in listbox. Format: y|x|func
    func_calls_sl.add(main_f.itoa(y)+'|'+main_f.itoa(x)+'|'+func_name);
  until c=0;
end;

//count number of parameters of function-header 's'
//par_min is the minimum-number of needed parameters
//because of functions like: function tst($a,$b='x')
function func_params_count(s,fn:string;var par_min:integer):integer;
var
  c:integer;
  par,err:string;
  brace_c:integer;
begin
  //isolate php-source because if function calls like:
  //full-source : tst($lim,($art==' ,,, '),$lim_txt)
  //php-isolated: tst($lim,($art=='.....'),$lim_txt)
  syntax_check_f.php_isolate(s,fn,false,err);

  result:=-1;par_min:=-1;

  //guilty function header width parameters?
  c:=pos('(',s);if c=0 then exit;

  //function is: tst($a,$b,$c='x')
  result:=0;par_min:=0;

  //isolate paramters: ($a,$b,$c='x')
  s:=copy(s,c+1,length(s));

  //cut braces: $a,$b,$c='x'
  s:=trim(copy(s,1,main_f.rpos(')',s)-1));

  //delete commas betwenn inner braces:
  //'$s,1,pas_pos('...',$s)-1' -> $s1,1,pas_pos(xxxxxxxx)-1
  brace_c:=0;
  for c:=1 to length(s) do
  begin
    if s[c]='(' then inc(brace_c);
    if s[c]=')' then
    begin
      dec(brace_c);
      s[c]:='x';
    end;
    if brace_c>0 then s[c]:='x';
  end;

  //count commas
  while s<>'' do
  begin
    c:=pos(',',s);if c=0 then c:=length(s)+1;

    //isolate found parameter: $a
    par:=trim(copy(s,1,c-1));

    result:=result+1;

    //is it a $c='x' parameter?
    if pos('=',par)>0 then inc(par_min);

    s:=copy(s,c+1,length(s));
  end;
  par_min:=result-par_min;
end;

//check 'php_src' for unknown and unused functions
procedure check(
  fn,full_src,php_src:string;
  funcs_all_sl,funcs_project_sl,funcs_unused_sl,funcs_unknown_sl,
  func_calls_sl:tstringlist
);

  //---------------------------------------------------------
  //check if func-definition-name is like func-call-name
  function check_def_call_same(def_s,call_s:string):bool;
  var
    c:integer;
  begin
    //ignore case
    def_s:=ansilowercase(def_s);    //tst($a,$b) - index.php
    call_s:=ansilowercase(call_s);  //tst

    //def_s-begin same as call_s?
    result:=false;
    if copy(def_s,1,length(call_s))<>call_s then exit;

    //more checks needed because of
    //def: tst2 call: tst

    //check for braces (some system function dont need them)
    if pos('(',def_s)=0 then
    begin
      //def_s: ini_set - system
      result:=(trim(copy(def_s,1,pos('-',def_s)-1))=call_s);
      exit;
    end;

    //check if def_s-function-name is complete
    //tst   ('a')
    c:=length(call_s)+1;
    while c<length(def_s) do
    begin
      if def_s[c]<>' ' then break;
      inc(c);
     end;
     if(c=length(call_s))or(def_s[c]<>'(')then exit;

     result:=true;
  end;

  //get entry number 'call_r' from 'func_calls_sl'
  //func widzh parameters in 'func_param', func-name in 'result'
  function func_calls_sl_get(r:integer;var func_param:string):string;
  begin
    //format: y|x|test('1','2')
    //test('1','2')
    func_param:=trim(main_f.delim_param_get(func_calls_sl[r],2,'|',''));
    //test
    result:=trim(copy(func_param,1,pos('(',func_param)-1));
  end;

  //delete functions calls from unused-functions-stringlist
  procedure del_used_funcs_from_unused_sl;
  var
    call_r,def_r:integer;
    call_s,def_s,func_par:string;
  begin
    //nothing to do?
    if not syntax_check_f.functions_unused_chb.Checked then exit;

    //check all function calls
    for call_r:=0 to func_calls_sl.count-1 do
    begin
      //get func-call function-naem:
      //y|x|test('1','2') -> test
      call_s:=func_calls_sl_get(call_r,func_par);

      //check all function in 'funcs_unused_sl'
      for def_r:=funcs_unused_sl.Count-1 downto 0 do
      begin
        //get entry: test($p1,$p2) - tst.php
        def_s:=funcs_unused_sl[def_r];

        //check if func-definition is like func-call
        if not check_def_call_same(def_s,call_s) then continue;

        //delete used function frim unused-function-listbox
        funcs_unused_sl.delete(def_r);
      end;
    end;
  end;

  //find unknow functions and function calls with wring parameters
  procedure funcs_unknown_sl_add;
  var
    x,y,call_r,def_r:integer;
    s,call_s,call_param_s,def_s,func_name:string;
    found_ok:bool;
    param_c,param_max,param_min,dummy:integer;
  begin
    //nothing to do?
    if not syntax_check_f.functions_unknown_chb.Checked then exit;
    if funcs_all_sl.count=0 then exit;

    //check all function calls
    for call_r:=0 to func_calls_sl.count-1 do
    begin
      //get entry: y|x|test('1','2') -> test
      call_s:=func_calls_sl_get(call_r,call_param_s);

      //check if call_s exists in funcs_all_sl
      found_ok:=false;
      for def_r:=0 to funcs_all_sl.count-1 do
      begin
        //get enty: test($p1,p2) - fn
        def_s:=funcs_all_sl[def_r];

        //def_s same as call_s?
        if not check_def_call_same(def_s,call_s) then continue;

        //yes, function is defined
        found_ok:=true;
        break;
      end;

      //function_call has definition?
      if not found_ok then
      begin
        //no, get full entry: y|x|test('1','2')
        call_s:=func_calls_sl[call_r];

        //add it to unknown-function-list
        funcs_unknown_sl.add(fn+'|'+call_s);
        continue;
      end;

      //function definition found

      //is it a system-defined function?
      //if so then make no parameter-check
      if funcs_project_sl.IndexOf(def_s)=-1 then continue;

      //user-defined function. Check parameters.

      //get (minimum) number of parameters of def_s
      param_max:=func_params_count(def_s,fn,param_min);

      //no parameters? then continue
      if param_max=-1 then continue;

      //get (minimum) number of parameters of call_s
      param_c:=func_params_count(call_param_s,fn,dummy);

      //number of parameters correct?
      if(param_c>=param_min)and(param_c<=param_max) then continue;

      //no, function call use wrong number of parameters

      //call_sl[call_r]='y|x|func'
      y:=strtoint(trim(main_f.delim_param_get(func_calls_sl[call_r],0,'|','0')));
      x:=strtoint(trim(main_f.delim_param_get(func_calls_sl[call_r],1,'|','0')));
      func_name:=trim(main_f.delim_param_get(func_calls_sl[call_r],2,'|',''));
      if param_c<param_min then s:='TOO LITTLE' else s:='TOO MUCH';
      s:=s+' Parameter? Definition: '+def_s;
      main_f.debug_add(_db_warning,fn,y,x,func_name,'',s);
    end;
  end;

begin
  //fill 'func_calls_sl' width all function calls in 'pgp_src'
  //func_calls_[0]='10|1|test('1','2')'
  //func_calls_[1]='200|20|test($a)'
  func_calls_sl.Clear;
  func_calls_scan(full_src,php_src,func_calls_sl);

  //delete functions calls from unused-functions-stringlist
  del_used_funcs_from_unused_sl;

  //find unknow functions and function calls with wring parameters
  funcs_unknown_sl_add;
end;

end.

