unit syntax_check_php_lint_u;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls,strutils;

procedure php_lint(fn:string);

implementation

uses main_u,syntax_check_u;

procedure php_lint(fn:string);

  //put founded lint-errors to debug-listbox
  procedure errors_to_debug_lb(s:string);
  var
    ms,ss:string;
    row,c:integer;
  begin
    //nothing to do?
    if pos('No syntax errors detected',s)>0 then exit;
    repeat
      c:=pos(lowercase(_debug_syntax_error),lowercase(s));
      if c=0 then break;

      s:=copy(s,c,length(s));

      c:=pos(_cr,s);if c=0 then c:=length(s)+1;
      ms:=copy(s,1,c-1);
      s:=copy(s,c+1,length(s));

      c:=pos('on line ',ms);
      if c>0 then
      begin
        ss:=copy(ms,c+8,length(ms));
        try
          row:=strtoint(copy(ss,1,c-1));
        except
          row:=-1;
        end;
        main_f.debug_add(_db_error,fn,row,1,'','',ms);
      end;
    until c=0;
  end;

var
  cmd,result_fn:string;
  tsi:TStartupInfo;
  tpi:TProcessInformation;
  dw:dword;
begin
  try
    //delete result-file
    result_fn:=main_f.home_dir+_debug_syntax_fn;
    deletefile(result_fn);

    //php.exe -l -f filename > syntax_check.tmp
    cmd:='cmd.exe /c '+syntax_check_f.php_fn_e.text+' -l -f "'+fn+'" > '+result_fn;

    //create an run process
    FillChar(tsi,SizeOf(TStartupInfo),0);
    tsi.cb:=SizeOf(TStartupInfo);
    tsi.wShowWindow:=sw_hide;
    tsi.dwFlags:=STARTF_USESHOWWINDOW;
    if CreateProcess(nil,pchar(cmd),nil,nil,false,CREATE_NEW_CONSOLE or NORMAL_PRIORITY_CLASS,nil,nil,tsi,tpi)then
    begin
      while WaitForSingleObject(tpi.hProcess,0)=WAIT_TIMEOUT do
      begin
        Application.ProcessMessages;
        Sleep(50);
      end;
      GetExitCodeProcess(tpi.hProcess,dw);
    end
    else
    begin
      main_f.error_msg('Cannot create process "'+cmd+'" - break! ERROR: '+inttostr(getlasterror()));
      exit;
    end;

    //is there a result-file?
    if fileexists(result_fn) then
    begin
      syntax_check_f.error_m.lines.loadfromfile(result_fn);
      errors_to_debug_lb(syntax_check_f.error_m.Text);
    end;

  finally
    main_f.lb_scrollwidth_set(main_f.debug_lb);
  end;
end;

end.
 