unit web_u;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, OleCtrls, SHDocVw, ComCtrls, StdCtrls, jpeg, ExtCtrls, Menus,
  Buttons,registry,shellapi,activex,clipbrd;

type
  Tweb_f = class(TForm)
    main_menu: TMainMenu;
    top_p: TPanel;
    top_img: TImage;
    url_l: TLabel;
    url_e: TEdit;
    status_p: TPanel;
    progressbar: TProgressBar;
    web_brws: TWebBrowser;
    file1: TMenuItem;
    file_close1: TMenuItem;
    mavi_home_sb: TSpeedButton;
    navi_back_sb: TSpeedButton;
    navi_stop_sb: TSpeedButton;
    navi_url_extern_sb: TSpeedButton;
    navi_url_sb: TSpeedButton;
    navi_refresh_sb: TSpeedButton;
    navi1: TMenuItem;
    navi_home1: TMenuItem;
    navi_back1: TMenuItem;
    navi_stop1: TMenuItem;
    navi_refresh1: TMenuItem;
    navi_url_extern1: TMenuItem;
    navi_url1: TMenuItem;
    navi_n1: TMenuItem;
    web1: TMenuItem;
    web_phpmyadmin1: TMenuItem;
    web_n1: TMenuItem;
    web_html_validate1: TMenuItem;
    web_css_validate1: TMenuItem;
    web_js_validate1: TMenuItem;
    win1: TMenuItem;
    win_small1: TMenuItem;
    win_middle1: TMenuItem;
    win_big1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);

    procedure file_close1Click(Sender: TObject);

    procedure navi_back1Click(Sender: TObject);
    procedure navi_stop1Click(Sender: TObject);
    procedure navi_refresh1Click(Sender: TObject);
    procedure navi_url_extern1Click(Sender: TObject);
    procedure navi_home1Click(Sender: TObject);

    procedure web_phpmyadmin1Click(Sender: TObject);
    procedure web_html_validate1Click(Sender: TObject);
    procedure web_css_validate1Click(Sender: TObject);
    procedure web_js_validate1Click(Sender: TObject);

    procedure win_small1Click(Sender: TObject);
    procedure win_middle1Click(Sender: TObject);
    procedure win_big1Click(Sender: TObject);

    procedure top_pResize(Sender: TObject);
    procedure web_brwsProgressChange(Sender: TObject; Progress,
      ProgressMax: Integer);
    procedure navi_url1Click(Sender: TObject);
    procedure web_brwsDocumentComplete(Sender: TObject;
      const pDisp: IDispatch; var URL: OleVariant);
    procedure url_eKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    home_url:string;
    function tags_del(s:string):string;
    procedure wb_src_to_clipboard;
    function wb_src_to_str(wb:twebbrowser):string;
    procedure wb_src_debug_scan(debug_type,s:string);
    procedure wb_debug_scan(wb:twebbrowser);
    procedure win_size_set(w,h:integer);
    procedure url_to_browser_extern(url:string);
  end;

var
  web_f: Tweb_f;

implementation

uses main_u;

{$R *.dfm}

//--------------------------------------------------------------
//FORM
//--------------------------------------------------------------

procedure Tweb_f.FormCreate(Sender: TObject);
begin
  web_brws.Align:=alclient;
  top_img.picture.Assign(main_f.top_img.picture);top_img.align:=alclient;
end;

procedure Tweb_f.FormShow(Sender: TObject);
begin
  if tag=0 then navi_url1Click(Sender);
  tag:=0;
end;

procedure Tweb_f.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  wb_debug_scan(web_brws);
end;

procedure Tweb_f.top_pResize(Sender: TObject);
begin
  navi_url_sb.Left:=top_p.Width-60;
  navi_url_extern_sb.Left:=top_p.Width-30;
  url_e.width:=navi_url_sb.Left-url_e.Left-10;
end;

//--------------------------------------------------------------
//MENU
//--------------------------------------------------------------

procedure Tweb_f.file_close1Click(Sender: TObject);
begin
  close;
end;

procedure Tweb_f.navi_home1Click(Sender: TObject);
begin
  web_brws.Navigate(home_url);
end;

procedure Tweb_f.navi_back1Click(Sender: TObject);
begin
  try web_brws.GoBack;except end;
end;

procedure Tweb_f.navi_stop1Click(Sender: TObject);
begin
  try web_brws.stop;except end;
end;

procedure Tweb_f.navi_refresh1Click(Sender: TObject);
begin
  try web_brws.Refresh;except end;
end;

procedure Tweb_f.navi_url1Click(Sender: TObject);
begin
  web_brws.Navigate(url_e.text);
end;

procedure Tweb_f.url_to_browser_extern(url:string);
var
  Browser: string;
begin
  Browser:='';
  with TRegistry.Create do
  begin
    try
      RootKey := HKEY_CLASSES_ROOT;
      Access := KEY_QUERY_VALUE;
      if OpenKey('\htmlfile\shell\open\command', False) then
        Browser := ReadString('');
      CloseKey;
    finally
      Free;
    end;
  end;
  if Browser='' then exit;
  Browser:=Copy(Browser,Pos('"',Browser)+1,Length(Browser)) ;
  Browser:=Copy(Browser,1,Pos('"',Browser)-1) ;
  ShellExecute(getdesktopWindow,'open',PChar(Browser),PChar(url),nil,SW_SHOW);
end;

procedure Tweb_f.navi_url_extern1Click(Sender: TObject);
begin
  url_to_browser_extern(url_e.text);
end;

procedure Tweb_f.web_phpmyadmin1Click(Sender: TObject);
begin
  url_to_browser_extern('http://127.0.0.1/phpmyadmin/index.php');
end;

// Save a Webbrowser Document to a string
function tweb_f.wb_src_to_str(wb:twebbrowser):string;

  // Save a TWebbrowser Document to a Stream
  procedure src_to_stream(Document:IDispatch;Stream:TStream);
  var
    PersistStreamInit:IPersistStreamInit;
    StreamAdapter:IStream;
  begin
    Assert(Assigned(Document));
    Stream.Size:=0;
    Stream.Position:=0;
    if Document.QueryInterface(IPersistStreamInit,PersistStreamInit)=S_OK then
    begin
      StreamAdapter:=TStreamAdapter.Create(Stream,soReference);
      PersistStreamInit.Save(StreamAdapter,False);
      StreamAdapter:=nil;
    end;
  end;

var
  Document:IDispatch;
  Stream: TStringStream;
begin
  Document:=wb.document;
  Result:='';
  Stream:=TStringStream.Create('');
  try
    src_to_stream(Document, Stream);
    Result:=StringReplace(Stream.Datastring, #$A#9, #$D#$A, [rfReplaceAll]);
    Result:=StringReplace(Result, #$A, #$D#$A, [rfReplaceAll]);
    if Copy(Result,1,3)='<' then Result:='';
  finally
    Stream.Free;
  end;
end;

procedure tweb_f.wb_src_to_clipboard;
var
  s:string;
begin
  s:=wb_src_to_str(web_brws);
  s:=stringreplace(s,_cr,#10,[rfreplaceall]);
  clipboard.AsText:=s;
  main_f.notice_msg('Source of webpage copied to clipboard');
end;

procedure Tweb_f.web_html_validate1Click(Sender: TObject);
var
  url:string;
begin
  wb_src_to_clipboard;
  url:='http://validator.w3.org/#validate_by_input+with_options';
  ShellExecute(getdesktopWindow,'open',PChar('iexplore.exe'),PChar(URL),nil,SW_SHOW);
end;

procedure Tweb_f.web_css_validate1Click(Sender: TObject);
var
  url:string;
begin
  wb_src_to_clipboard;
  url:='http://jigsaw.w3.org/css-validator/#validate_by_input+with_options';
  ShellExecute(getdesktopWindow,'open',PChar('iexplore.exe'),PChar(URL),nil,SW_SHOW);
end;

procedure Tweb_f.web_js_validate1Click(Sender: TObject);
var
  url:string;
begin
  wb_src_to_clipboard;
  url:='http://www.javascriptlint.com/online_lint.php';
  ShellExecute(getdesktopWindow,'open',PChar('iexplore.exe'),PChar(URL),nil,SW_SHOW);
end;

procedure Tweb_f.win_size_set(w,h:integer);
begin
  LockWindowUpdate(Handle);
  try
    windowstate:=wsnormal;
    width:=w;
    height:=h;
    left:=(screen.width-width)div 2;
    top:=(screen.height-height)div 2;
  finally
    LockWindowUpdate(0);
  end;
end;

procedure Tweb_f.win_small1Click(Sender: TObject);
begin
  win_size_set(640,480-50);
end;

procedure Tweb_f.win_middle1Click(Sender: TObject);
begin
  win_size_set(800,600-40);
end;

procedure Tweb_f.win_big1Click(Sender: TObject);
begin
  win_size_set(1024,768-30);
end;

//--------------------------------------------------------------
//WEBBROWSER
//--------------------------------------------------------------

procedure Tweb_f.web_brwsProgressChange(Sender: TObject; Progress,
  ProgressMax: Integer);
begin
  progressbar.Max:=progressmax;
  progressbar.position:=progress;
end;

procedure Tweb_f.web_brwsDocumentComplete(Sender: TObject;
  const pDisp: IDispatch; var URL: OleVariant);
begin
  url_e.Text:=url;
end;

procedure Tweb_f.url_eKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if key=vk_return then navi_url1Click(Sender);
end;

//--------------------------------------------------------------
//SOURCE SCAN
//--------------------------------------------------------------

//filter tags out of string
//'line1<hr>line2' => 'line1    line2'
function tweb_f.tags_del(s:string):string;
var
  c:integer;
  ss:string;
  tagok:bool;
begin
  tagok:=false;
  ss:='';
  for c:=1 to length(s) do
  begin
    if s[c]='<' then tagok:=true;
    if not tagok then ss:=ss+s[c];
    if s[c]='>' then tagok:=false;
  end;
  result:=ss;
end;

procedure tweb_f.wb_src_debug_scan(debug_type,s:string);
var
  fn,msg,ss:string;
  row,c:integer;
begin
  repeat
    c:=pos(lowercase(debug_type),lowercase(s));
    if c=0 then break;

    //Undefined variable: foo in <B>C:\tmp\index.php</B> on line <B>36</B><BR>[REST]

    s:=copy(s,c+length(debug_type),length(s));
    c:=pos('<BR>',s);

    //[REST]
    ss:=copy(s,c+3,length(s));

    //Undefined variable: foo in <B>C:\tmp\index.php</B> on line <B>36</B>
    s:=copy(s,1,c-1);
    c:=pos('<B>',s);

    //Undefined variable: foo
    msg:=tags_del(trim(copy(s,1,c-4)));

    //<B>C:\tmp\index.php</B> on line <B>36</B>
    s:=copy(s,c+3,length(s));
    c:=pos('</B>',s);

    //C:\tmp\index.php
    fn:=copy(s,1,c-1);

    //on line <B>36</B>
    s:=copy(s,c+3,length(s));
    c:=pos('<B>',s);

    //36</B>
    s:=copy(s,c+3,length(s));

    c:=pos('</B>',s);
    try
      //36
      row:=strtoint(copy(s,1,c-1));
    except
      row:=-1;
    end;
    main_f.debug_add(uppercase(tags_del(debug_type)),fn,row,1,'','',msg);
    s:=ss;

  until c=0;
end;

//scan html document for apache error messages
procedure tweb_f.wb_debug_scan(wb:twebbrowser);
var
  s:string;
begin
  try
    s:=wb.OleObject.document.body.innerHTML;
    main_f.debug_lb.items.Clear;
    wb_src_debug_scan(_debug_error,s);
    wb_src_debug_scan(_debug_warn,s);
    wb_src_debug_scan(_debug_notice,s);
    main_f.lb_scrollwidth_set(main_f.debug_lb);
    main_f.lb_pctrl.activepage:=main_f.debug_ts;
  except
    //no source, for example pdf
  end;
end;

end.

